# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Showing do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :ListingKeyNumeric,
    :ShowingAgentKeyNumeric,
    :ShowingKeyNumeric,
    :AgentOriginatingSystemID,
    :AgentOriginatingSystemName,
    :AgentSourceSystemID,
    :AgentSourceSystemName,
    :ListingId,
    :ListingKey,
    :ListingOriginatingSystemID,
    :ListingOriginatingSystemName,
    :ListingSourceSystemID,
    :ListingSourceSystemName,
    :OriginatingSystemAgentKey,
    :OriginatingSystemListingKey,
    :OriginatingSystemShowingKey,
    :ShowingAgentKey,
    :ShowingAgentMlsID,
    :ShowingId,
    :ShowingKey,
    :ShowingOriginatingSystemID,
    :ShowingOriginatingSystemName,
    :ShowingSourceSystemID,
    :ShowingSourceSystemName,
    :SourceSystemAgentKey,
    :SourceSystemListingKey,
    :SourceSystemShowingKey,
    :ModificationTimestamp,
    :OriginalEntryTimestamp,
    :ShowingEndTimestamp,
    :ShowingRequestedTimestamp,
    :ShowingStartTimestamp,
    :ShowingAgent,
    :AgentOriginatingSystem,
    :AgentSourceSystem,
    :ListingOriginatingSystem,
    :ListingSourceSystem,
    :ShowingOriginatingSystem,
    :ShowingSourceSystem,
    :Property
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :ListingKeyNumeric => float() | nil,
    :ShowingAgentKeyNumeric => float() | nil,
    :ShowingKeyNumeric => float() | nil,
    :AgentOriginatingSystemID => String.t | nil,
    :AgentOriginatingSystemName => String.t | nil,
    :AgentSourceSystemID => String.t | nil,
    :AgentSourceSystemName => String.t | nil,
    :ListingId => String.t | nil,
    :ListingKey => String.t | nil,
    :ListingOriginatingSystemID => String.t | nil,
    :ListingOriginatingSystemName => String.t | nil,
    :ListingSourceSystemID => float() | nil,
    :ListingSourceSystemName => String.t | nil,
    :OriginatingSystemAgentKey => String.t | nil,
    :OriginatingSystemListingKey => String.t | nil,
    :OriginatingSystemShowingKey => String.t | nil,
    :ShowingAgentKey => String.t | nil,
    :ShowingAgentMlsID => String.t | nil,
    :ShowingId => String.t | nil,
    :ShowingKey => String.t | nil,
    :ShowingOriginatingSystemID => String.t | nil,
    :ShowingOriginatingSystemName => String.t | nil,
    :ShowingSourceSystemID => float() | nil,
    :ShowingSourceSystemName => String.t | nil,
    :SourceSystemAgentKey => String.t | nil,
    :SourceSystemListingKey => String.t | nil,
    :SourceSystemShowingKey => String.t | nil,
    :ModificationTimestamp => Date.t | nil,
    :OriginalEntryTimestamp => Date.t | nil,
    :ShowingEndTimestamp => Date.t | nil,
    :ShowingRequestedTimestamp => Date.t | nil,
    :ShowingStartTimestamp => Date.t | nil,
    :ShowingAgent => FoyerAPI.Model.Member.t | nil,
    :AgentOriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :AgentSourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :ListingOriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :ListingSourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :ShowingOriginatingSystem => FoyerAPI.Model.Ouid.t | nil,
    :ShowingSourceSystem => FoyerAPI.Model.Ouid.t | nil,
    :Property => FoyerAPI.Model.Property.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Showing do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:ModificationTimestamp, :date, nil, options)
    |> deserialize(:OriginalEntryTimestamp, :date, nil, options)
    |> deserialize(:ShowingEndTimestamp, :date, nil, options)
    |> deserialize(:ShowingRequestedTimestamp, :date, nil, options)
    |> deserialize(:ShowingStartTimestamp, :date, nil, options)
    |> deserialize(:ShowingAgent, :struct, FoyerAPI.Model.Member, options)
    |> deserialize(:AgentOriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:AgentSourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ListingOriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ListingSourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ShowingOriginatingSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:ShowingSourceSystem, :struct, FoyerAPI.Model.Ouid, options)
    |> deserialize(:Property, :struct, FoyerAPI.Model.Property, options)
  end
end

